VERSION 5.00
Object = "{67397AA1-7FB1-11D0-B148-00A0C922E820}#6.0#0"; "MSADODC.OCX"
Object = "*\A..\AlphaImgControl\LaVolpeAlphaImg.vbp"
Begin VB.Form frmDataBound 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Sample Databinding"
   ClientHeight    =   2775
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2775
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete Record"
      Height          =   465
      Left            =   165
      TabIndex        =   1
      Top             =   1215
      Width           =   2190
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add New Record"
      Height          =   465
      Left            =   165
      TabIndex        =   0
      Top             =   750
      Width           =   2190
   End
   Begin VB.CommandButton cmdPic 
      Caption         =   "Update Logo >>"
      Height          =   465
      Left            =   165
      TabIndex        =   2
      Top             =   1695
      Width           =   2190
   End
   Begin VB.TextBox txtName 
      Height          =   330
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   300
      Width           =   2220
   End
   Begin MSAdodcLib.Adodc Adodc1 
      Height          =   330
      Left            =   150
      Top             =   2310
      Width           =   4470
      _ExtentX        =   7885
      _ExtentY        =   582
      ConnectMode     =   0
      CursorLocation  =   3
      IsolationLevel  =   -1
      ConnectionTimeout=   15
      CommandTimeout  =   30
      CursorType      =   3
      LockType        =   3
      CommandType     =   8
      CursorOptions   =   0
      CacheSize       =   50
      MaxRecords      =   0
      BOFAction       =   0
      EOFAction       =   0
      ConnectStringType=   1
      Appearance      =   1
      BackColor       =   -2147483643
      ForeColor       =   -2147483640
      Orientation     =   0
      Enabled         =   -1
      Connect         =   ""
      OLEDBString     =   ""
      OLEDBFile       =   ""
      DataSourceName  =   ""
      OtherAttributes =   ""
      UserName        =   ""
      Password        =   ""
      RecordSource    =   ""
      Caption         =   "Adodc1"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      _Version        =   393216
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Company Logo"
      Height          =   225
      Index           =   1
      Left            =   2505
      TabIndex        =   5
      Top             =   60
      Width           =   2115
   End
   Begin VB.Label Label1 
      Caption         =   "Company Name"
      Height          =   225
      Index           =   0
      Left            =   195
      TabIndex        =   4
      Top             =   60
      Width           =   2115
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl AlphaImgCtl1 
      Height          =   1815
      Left            =   2490
      Top             =   360
      Width           =   2115
      _ExtentX        =   3731
      _ExtentY        =   3201
      Frame           =   148
      Border          =   16711680
      Attr            =   514
      Effects         =   "frmDataBound.frx":0000
   End
End
Attribute VB_Name = "frmDataBound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' data binding can make reading/writing tables very easy
' The LoadPictureGDIplus file has more information on databinding
' the AlphaImageCtl. This project is not designed to teach you how to
' use the ADODC control; nor how to manipulate a database

Private myRS As ADODB.Recordset

Private Sub Form_Load()

    ' instead of passing a database with this project, we will create a simple run-time
    ' ADODB recordset and use that as a table for this project

    On Error Resume Next
    Set myRS = New ADODB.Recordset
    
    ' create 2 fields, one text, one binary
    myRS.Fields.Append "Company", adVarChar, 255, adFldUpdatable
    myRS.Fields.Append "Logo", adVarBinary, -1, adFldIsNullable Or adFldLong Or adFldUpdatable
    myRS.Open
    
    If Err Then
        MsgBox "Failed to create run-time recordset", vbCritical + vbOKOnly
        Unload Me
    Else
    
        ' populate the table with 3 sample records
        myRS.AddNew "Company", "LaVolpe Enterprises"
        myRS.AddNew "Company", "Some Company, USA"
        myRS.AddNew "Company", "Just a Bit O'Fun"
        
        ' assign this recordset to the adodc
        Set Adodc1.Recordset = myRS
    
        ' bind the text box to the Company field
        txtName.DataField = "Company"
        Set txtName.DataSource = Adodc1
        ' bind the alpha image control to the logo field
        AlphaImgCtl1.DataBindings(0).DataField = "Logo"
        Set AlphaImgCtl1.DataBindings(0).DataSource = Adodc1
    
        myRS.MoveFirst  ' forces the adodc move event which updates the adodc caption
    End If
    
End Sub

Private Sub AlphaImgCtl1_UpdateDataboundImage(theImage As LaVolpeAlphaImg.GDIpImage)
    ' the database is about to be updated with the "theImage" parameter above
    ' here is the time to either resize, replace, or modify what will be saved
    ' You can use LoadPictureGDIplus to use a different image or even set theImage to Nothing
    ' You can use SavePictureGDIplus to resize the image or convert it to a preferred format, like PNG for example
    
    ' in this example, I will resize the image to no greater than 128x128 and always make it PNG
    Dim ss As SAVESTRUCT, Cx As Long, Cy As Long
    If theImage.Handle Then
        If theImage.Width > 128 Or theImage.Height > 128 Then
            GetScaledImageSize theImage.Width, theImage.Height, 128, 128, Cx, Cy
            ss.Width = Cx: ss.Height = Cy
        ElseIf theImage.ImageFormat <> lvicPicTypePNG Then
            ss.Width = theImage.Width: ss.Height = theImage.Height
        End If
        If ss.Width Then SavePictureGDIplus theImage, theImage, lvicSaveAsPNG, ss
    End If
    
End Sub

Private Sub Adodc1_MoveComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.Recordset)
    
    ' simply update the adodc control's caption
    If pRecordset.EOF Then
        Adodc1.Caption = "end of table"
        cmdPic.Enabled = False
    ElseIf pRecordset.BOF Then
        Adodc1.Caption = "start of table"
        cmdPic.Enabled = False
    Else
        Adodc1.Caption = "Record " & pRecordset.AbsolutePosition & " of " & pRecordset.RecordCount
        cmdPic.Enabled = True
    End If
    cmdDelete.Enabled = cmdPic.Enabled
    
End Sub

Private Sub cmdAdd_Click()
    
    Dim sCompany As String
    sCompany = InputBox("Enter new company name", "New Record", "")
    If Len(sCompany) Then
        myRS.AddNew
        txtName = sCompany
        myRS.Update
    End If
End Sub

Private Sub CmdDelete_Click()
    
    myRS.Delete
    myRS.MoveNext

End Sub

Private Sub cmdPic_Click()
    
    Dim lResult As Long
    
    If AlphaImgCtl1.Picture.Handle Then
        lResult = MsgBox("Delete the current logo?", vbYesNo + vbQuestion + vbDefaultButton2, "Delete Logo")
    End If
    
    If lResult = vbYes Then
        Set AlphaImgCtl1.Picture = Nothing
    Else
    
        Dim cBrowser As UnicodeFileDialog
        Set cBrowser = New UnicodeFileDialog
        With cBrowser
            .Filter = "All Files|*.*|" & _
                "Supported Formats|*.bmp;*.cur;*.ani;*.avi;*.gif;*.ico;*.jpg;*.jpeg;*.emf;*.wmf;*.mp3;*.wma;*.pcx;*.png;*.pam;*.pnm;*.pgm;*.pbm;*.ppm;*.apng;*.tga;*.tif;*.tiff;*.exe;*.dll;*.ocx|" & _
                "Audio Video Interleave (AVI)|*.avi|Bitmap|*.bmp|Cursor|*.cur;*.ani|Executables (dll,exe,ocx)|*.exe;*.dll;*.ocx|GIF|*.gif|Icon|*.ico|JPEG|*.jpg;*.jpeg|" & _
                "Metafiles|*.emf;*.wmf|Music (MP3 WMA)|*.mp3;*.wma|PC Paintbrush (PCX)|*.pcx|PNG|*.png;*.apng|Portable Bitmap|*.pnm;*.pbm;*.pgm;*.ppm;*.pam|" & _
                "Targa (TGA)|*.tga|TIFF|*.tif;*.tiff"
            .FilterIndex = 2
            .Flags = OFN_EXPLORER Or OFN_FILEMUSTEXIST
            .DialogTitle = "Select Logo"
        End With
        If cBrowser.ShowOpen(Me.hWnd) Then
            On Error Resume Next
            Set AlphaImgCtl1.Picture = LoadPictureGDIplus(cBrowser.FileName)
            If Err Then MsgBox "Invalid image selected. Try again", vbExclamation + vbOKOnly
        End If
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)

    On Error Resume Next
    myRS.Close
    Set myRS = Nothing

End Sub
