VERSION 5.00
Object = "*\A..\AlphaImgControl\LaVolpeAlphaImg.vbp"
Begin VB.Form frmClock 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "frmClock"
   ClientHeight    =   2535
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3405
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2535
   ScaleWidth      =   3405
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Left            =   2490
      Top             =   225
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl aicSecond 
      Height          =   1455
      Left            =   960
      Top             =   945
      Width           =   1455
      _ExtentX        =   2566
      _ExtentY        =   2566
      Blend           =   0
      Attr            =   514
      Object.Index           =   65537
      Effects         =   "frmClock.frx":0000
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl aicMinute 
      Height          =   1455
      Left            =   660
      Top             =   600
      Width           =   1455
      _ExtentX        =   2566
      _ExtentY        =   2566
      Blend           =   0
      Attr            =   514
      Object.Index           =   65537
      Effects         =   "frmClock.frx":0018
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl aicHour 
      Height          =   1455
      Left            =   390
      Top             =   360
      Width           =   1455
      _ExtentX        =   2566
      _ExtentY        =   2566
      Blend           =   0
      Attr            =   514
      Object.Index           =   65537
      Effects         =   "frmClock.frx":0030
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl aicFace 
      Height          =   1455
      Left            =   165
      Top             =   120
      Width           =   1455
      _ExtentX        =   2566
      _ExtentY        =   2566
      Blend           =   0
      Attr            =   514
      Object.Index           =   65537
      Effects         =   "frmClock.frx":0048
   End
End
Attribute VB_Name = "frmClock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
 ' IF YOU GOT ERRORS LOADING THIS. WHEN YOU CLOSE IT, DO NOT SAVE !!!!!!

' How to load this project with the uncompiled alpha image control...
' Copy & paste these steps into Notepad if needed, so you can follow them
' 1. Open the project LaVolpeAlphaImg.vbp project first
' 2. From that project's IDE menus, select: File | Add Project
' 3. Close this project & navigate to & select this project
' 4. From the LaVolpeAlphaImg project explorer (tree view), select the prjClock project
' 5. Right click on it and select: Set as Start Up
' 6. Now run that project



 ' see comments below for this object
Private imgClockFace As GDIpImage
Private handsOffset As Long
Private mergeMode As Boolean

Private Sub Form_Load()

    ' see the comments below regarding merging the image.
    ' If you'd like to compare merged vs. un-merged, change the mergeMode value to False
    
    mergeMode = True

    Me.ScaleMode = vbPixels ' usercontrol deals in pixels only. Let's make scalemode pixels for ease
    
    ' Note: I'm not hiding anything in the res file, if you wish to extract these to your hard drive,
    '   here is how you go about it. Do this for each of the 4 images below:
            ' Dim bData() As Byte
            ' Open "C:\Clockface.png" For Binary As #1
            ' bData() = LoadResData("ClockFace", "Custom")
            ' Put #1, 1, bData()
            ' Close #1
    ' load the clock parts from the resource file
    Set aicFace.Picture = LoadPictureGDIplus(LoadResData("ClockFace", "Custom"), False)
    Set aicHour.Picture = LoadPictureGDIplus(LoadResData("ClockHrHand", "Custom"), False)
    Set aicMinute.Picture = LoadPictureGDIplus(LoadResData("ClockMinHand", "Custom"), False)
    Set aicSecond.Picture = LoadPictureGDIplus(LoadResData("ClockSecHand", "Custom"), False)

    Dim imageSizeX As Long
    
    ' get clock face scaled to our form size
    GetScaledImageSize aicFace.Picture.Width, aicFace.Picture.Height, Me.ScaleWidth - 10, Me.ScaleHeight - 10, imageSizeX, 0&
    
    ' center the clock face & resize
    With aicFace
        .Move (Me.ScaleWidth - imageSizeX) \ 2, (Me.ScaleHeight - imageSizeX) \ 2, imageSizeX, imageSizeX
    End With
    
    ' The hour, minute & second hands are just a tad larger than I like, so we'll resize them down a bit
    ' All 4 images are 130x130 at full size
    handsOffset = 6 * (imageSizeX / aicFace.Picture.Width)
    imageSizeX = imageSizeX - handsOffset * 2
    
    ' Now position & size the clock hands over the clock face, centering on the clock face
    If mergeMode = False Then ' if merging then no need to position these 2, we won't be displaying them
        With aicHour
            .Move aicFace.Left + handsOffset, aicFace.Top + handsOffset, imageSizeX, imageSizeX
            .Aspect = lvicFixedSize
        End With
        With aicMinute
            .Move aicFace.Left + handsOffset, aicFace.Top + handsOffset, imageSizeX, imageSizeX
            .Aspect = lvicFixedSize
        End With
    End If
    With aicSecond
        .Move aicFace.Left + handsOffset, aicFace.Top + handsOffset, imageSizeX, imageSizeX
        .Aspect = lvicFixedSize
    End With
    
    ' so what's that .Aspect = lvicFixedSize stuff?
    ' Some images are created with a buffer around the image to allow the image content to rotate 360 degrees.
    ' In other words, if we didn't resize the image, the clock hands would not be clipped when rotated.
    ' In those cases, we don't want to rotate and scale the image because it results in extra scaling when the
    '   image shouldn't be adjusted due to rotation. This special scaling option prevents the image from
    '   ever being resized again, regardless of AutoSize settings, control resizing, whatever. The only way
    '   to resize the image is to select a different Stretch property
    
    ' There is another option built in. We could have made the AutoSize property = lvicMultiAngle. That would
    ' resize the control large enough to render the entire image (buffer space and all), at any angle without
    ' clipping. But it would have made a much larger usercontrol size than desired. Either method will work.
    
    ' Note: Because we have 4 overlapping images, a lot of drawing is going on here.
    '   The Second hand is top most. Each time it rotates, it forces a redraw on the next image under it & so on
    '   Additionally, whenever a lower image is redrawn, it also causes the ones above it to redraw
    '   But VB is smart enough to start from the bottom up so that an infinite rendering loop isn't created.
   
    '   So using the clock as 4 images, when at exactly the top of any hour...
    '       Hour hand moves & causes all 4 overlapped areas to be repainted
    '       Minute hand moves & causes all 4 overlapped areas to be repainted
    '       Second hand moves & causes all 4 overlapped areas to be repainted
    '   That's a lot of painting. The second hand causes 4 repaints every time it moves, without the hr/min hand moving
    
    ' There is a bit of an efficiency tweak if you want to get creative.
    '   Since the minute hand only movee every 60 seconds, why not create an image of the
    '   current time that has the clock face, hour & minute hand positioned. Now when the
    '   second hand moves, it causes just 2 repaints.  When the minute changes, re-create
    '   that combined image.
    
    ' The control has a function for that: MergePictureGDIplus. It does require some work on your part,
    '   but maybe you'll find it worth it.  To show how easy it is, we'll do it every time the minute hand changes.
    ' Look at the Timer1_Event routine to see it in action.  Does require we use 1 additional image
    ' You know its working as advertised because the hour & minute hand controls are hidden
    
    If mergeMode Then CreateOverlayedImage Now()
        
    Call Timer1_Timer           ' ensure second hand is set
    Timer1.Interval = 500       ' start timer
    Timer1.Enabled = True
    
End Sub

Private Sub Timer1_Timer()
    
    ' we could actually call this dozens of times a second and it would not cause
    ' extra painting. Setting the angle that results in no change, does not update the control
    
    Dim t As Date
    t = Now()
    If mergeMode Then
        If Second(t) = 0 Then   ' calling this every 1/2 second
            ' possible to get here twice while Second(t)=0; don't want to do overlay twice for the same Time
            If aicSecond.Rotation > 0& Then Call CreateOverlayedImage(t)
        End If
    Else
        aicHour.Rotation = (Hour(t) Mod 12) * 30 + Minute(t) \ 3
        aicMinute.Rotation = Minute(t) * 6
    End If
    aicSecond.Rotation = (Second(t) * 6)
End Sub

Private Sub CreateOverlayedImage(curTime As Date)

    Dim pms As PICTUREMERGESTRUCT
    
    If imgClockFace Is Nothing Then
        ' first time thru, let's cache the clock face image
        Set imgClockFace = aicFace.Picture
        aicHour.Visible = False
        aicMinute.Visible = False
    End If
    
    With pms
        .CanvasHeight = aicFace.Height
        .CanvasWidth = aicFace.Width
        .Pictures = 3
        ReDim .MIS(0 To 2)
        ' do the clock face first
        Set .MIS(0).Picture = imgClockFace
            .MIS(0).Width = pms.CanvasWidth
            .MIS(0).Height = pms.CanvasHeight
            With .MIS(0).RSS
                ' and for a bit of fun... change the clockface color slightly every 10 mins
                Set .Effects = New GDIpEffects
                Select Case Minute(curTime) \ 10
                Case 0: .Effects.BlendColor = vbBlue
                Case 1: .Effects.BlendColor = vbGreen
                Case 2: .Effects.BlendColor = vbRed
                Case 3: .Effects.BlendColor = vbCyan
                Case 4: .Effects.BlendColor = vbMagenta
                Case 5: .Effects.BlendColor = vbYellow
                End Select
                .Effects.BlendPct = 22
            End With
        ' now do the hour hand
        Set .MIS(1).Picture = aicHour.Picture
            .MIS(1).Left = handsOffset
            .MIS(1).Top = handsOffset
            .MIS(1).Width = aicFace.Width - handsOffset * 2
            .MIS(1).Height = aicFace.Height - handsOffset * 2
            
            .MIS(2) = .MIS(1)
            .MIS(1).RSS.Angle = (Hour(curTime) Mod 12) * 30 + Minute(curTime) \ 3
        ' now do the minute hand
        Set .MIS(2).Picture = aicMinute.Picture
            .MIS(2).RSS.Angle = Minute(curTime) * 6
    End With
    ' merge all 3 images into 1 image
    Set aicFace.Picture = MergePictureGDIplus(pms)

'    Timer1.Enabled = False
End Sub
